directories
end_directories;

settings
  operation_mode = real_time;
  startup_options
    call_procedures = true;
    activate_receivers = true;
    output_action = set_local;
  end_startup_options;
  independent_procedure_execution = true;
end_settings;

driver
  Generator {driver = 'VSOURCE.DLL'; map_file = 'VSOURCE.DMF'; parameter_file = 'VSOURCE.PAR'};
end_driver;

data

  var
    F1 : boolean {init_value = true};
    cXAxisBeginning : boolean {init_value = true};
    cXAxisPosition : boolean {init_value = true};
    cYAxisPosition : boolean {init_value = true};
    cYAxisArrange : boolean {init_value = true};
    cLegendPosition : boolean {init_value = true};
    cChartType : boolean {init_value = false};
    cChartOrientation : boolean {init_value = true};
    aa : array[ 0..1 ] of string {init_value = 'horizontal'};
    s1 : string;
    cht : cardinal;
  end_var;

  channel CHAN {driver = Generator; direction = input};
    CH1 : real {driver_index = 1};
    CH2 : real {driver_index = 2};
    CH3 : real {driver_index = 3};
    CH4 : real {driver_index = 4};
    CH5 : real {driver_index = 5};
    CH6 : real {driver_index = 6};
    CH7 : real {driver_index = 7};
    CH8 : real {driver_index = 8};
  end_channel;

  expression E1;
    e_1 = CHAN.CH2 - 10;
  end_expression;

  archive A1 {period = 1; period_offset = 0; period_origin = midnight};
    r1 = CH1 {comment = '1. prubeh'; color = lred};
    r2 = CH2 {comment = '2. prubeh'; color = lblue};
  end_archive;

  archive A2 {period = 2; period_offset = 0; period_origin = midnight};
    r3 = CH3 {comment = '3. prubeh'; color = lgreen};
    r4 = CH4 {comment = '4. prubeh'; color = lmagenta};
  end_archive;

  archive A3 {period = 3; period_offset = 0; period_origin = midnight};
    r5 = CH5 {color = red};
    r6 = CH6 {color = blue};
  end_archive;

  archive A4 {period = 3; period_offset = 0; period_origin = midnight};
    r1 = CH1 {color = lgreen};
    r2 = CH2 {color = lblue};
  end_archive;

  archive A5 {period = 1.5; period_offset = 1; period_origin = midnight};
    r1 = CH1 {color = lred};
    r2 = CH2 {color = lblue};
  end_archive;

  archive A6 {period = 2.5; period_offset = 2; period_origin = midnight};
    r1 = CH1 {color = lred};
    r2 = CH2 {color = lblue};
  end_archive;

end_data;

timer

  selector SelectTimer;
    static
      cc : cardinal;
    end_static;

    activity
      period = 20;
    end_activity;
    case
      F1_case = F1 and cYAxisArrange and ( cc % 1 = 0 );
      F2_case = F1 and cXAxisBeginning and ( cc % 2 = 0 );
      F3_case = F1 and cXAxisPosition and ( cc % 3 = 0 );
      F4_case = F1 and cYAxisPosition and ( cc % 4 = 0 );
      F5_case = F1 and cLegendPosition and ( cc % 5 = 0 );
      F6_case = F1 and cChartType and ( cc % 4 = 0 );
      F7_case = F1 and cChartOrientation and ( cc % 6 = 0 );
      F8_case = F1 and ( cc % 3 = 0 );
    end_case;

    procedure OnActivate();
    begin
      cc = cc + 1;
    end_procedure;

  end_selector;

end_timer;

instrument

  data_viewer dv1;
    rem = '';
    activity
      period = 2.5;
    end_activity;
    gui
      owner = background;
      position = 65, 50, 795, 535;
      gravity = right, bottom;
      access = [ 0..1 ];
      bubble = '';
      window
        type = normal;
        title = '';
      end_window;
    end_gui;
    startup_options
      call_procedures = true;
      activate_receivers = true;
    end_startup_options;
    content = title, legend, tool_bar, scroll_bar, x_axis, y_axis, values, grid, limits;
    tool_content = change_group, change_mode, browse, axes_arrange, print, settings, edit_look, edit_time_axis, edit_y_axes, edit_groups, edit_grid, edit_title, edit_legend, edit_values, edit_print_page;
    user_rights = all;
    chart_description
      time_axis
        content = time, date, time_stamp;
        label = 'asov osa';
        time_mask = 'HH:mm:ss,f';
      end_time_axis;
      y_axes
        axis_element
          name = 'Y1';
          units = 'cc';
          scale_type = log;
          low_limit = -25;
          minor_incr = 2;
        end_axis_element;
        axis_element
          name = 'Y2';
          units = 'mm';
          low_limit = 20;
          high_limit = 80;
          minor_incr = 2;
        end_axis_element;
        axis_element
          name = 'Y3';
          range_to = 120;
          low_limit = 30;
          high_limit = 90;
          minor_incr = 2;
        end_axis_element;
      end_y_axes;
    end_chart_description;
    table_description
      font = 'MS Shell Dlg (Central European)', 8, normal;
    end_table_description;
    data_group
      group_name = 'G1';
      title = 'Skupina 1';
      item
        data_element = A1.r1;
      end_item;
      item
        data_element = A2.r3;
      end_item;
      item
        data_element = A3.r5;
      end_item;
    end_data_group;
    data_group
      group_name = 'G2';
      title = 'Skupina 2';
      item
        data_element = A1.r2;
      end_item;
      item
        data_element = A3.r6;
      end_item;
    end_data_group;
    data_group
      group_name = 'G3';
      title = 'Skupina 3';
      item
        data_element = 'A4.*';
      end_item;
    end_data_group;
    data_group
      group_name = 'G4';
      title = 'Skupina 3';
      item
        data_element = A1.r1;
        axis_name = 'Y1';
      end_item;
      item
        data_element = A2.r4;
        axis_name = 'Y1';
      end_item;
      item
        data_element = 'A3.*';
        axis_name = 'Y2';
      end_item;
      item
        data_element = 'A4.*';
        axis_name = 'Y3';
      end_item;
    end_data_group;
    active_group = 'G4';
    title
      refresh_title = false;
      text = 'Titulek grafu';
      font = 'Tahoma (Central European)', 10, bold;
      font_2 = 'Tahoma (Central European)', 8, normal;
      group_font = 'Tahoma (Central European)', 8, normal;
      paper_color = lcyan;
      frame = true;
      frame_color = lblue;
    end_title;
    mask_element
      section_mask = '*';
      element_mask = '*';
    end_mask_element;
    blink_colors
      background_color = lyellow;
    end_blink_colors;

    procedure OnModeChanged( TableMode, HistoryMode : boolean );
    begin
       F1 = not HistoryMode;
    end_procedure;

  end_data_viewer;

  program P01;
    activity
      timer = SelectTimer.F1_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      dv1.ChangeYAxisArrange();
    end_procedure;

  end_program;

  program P02;
    activity
      timer = SelectTimer.F2_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      dv1.ChangeXAxisBeginning();
    end_procedure;

  end_program;

  program P03;
    activity
      timer = SelectTimer.F3_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      dv1.ChangeXAxisPosition();
    end_procedure;

  end_program;

  program P04;
    activity
      timer = SelectTimer.F4_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      dv1.ChangeYAxisPosition();
    end_procedure;

  end_program;

  program P05;
    static
      cc : cardinal;
    end_static;

    activity
      timer = SelectTimer.F5_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      cc = (cc + 1) % 4;
      dv1.SetLegendPosition(cc);
    end_procedure;

  end_program;

  program P06;
    static
      cc : cardinal;
    end_static;

    activity
      timer = SelectTimer.F6_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      cc = (cc + 1) % 4;
      dv1.SetChartType(cc);
    end_procedure;

  end_program;

  program P07;
    static
      cc : cardinal;
    end_static;

    activity
      timer = SelectTimer.F7_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      dv1.ChangeChartOrientation();
    end_procedure;

  end_program;

  program P08;
    static
      cc : cardinal;
    end_static;

    activity
      timer = SelectTimer.F8_case, 1;
    end_activity;

    procedure OnActivate();
    begin
      cht = (cht + 1) % 5;
      dv1.SetSeriesChartType( 'A4.r1', cht );
    end_procedure;

  end_program;

  program startup;

    procedure OnActivate();
    begin
      aa[1] = 'vertical';
    end_procedure;

  end_program;

end_instrument;

